Subject: Re: bug#30569: Packages count as installed twice

From: Gábor Boskovits <[email-masked]>
Date: Wed, 28 Feb 2018 08:50:42 +0100

2018-02-27 22:55 GMT+01:00 Ludovic Courtès <[email-masked]>:

> Andreas Enge <[email-masked]> skribis:
>
> > On Wed, Feb 21, 2018 at 11:14:21PM +0100, Ricardo Wurmus wrote:
> >> Even so, you’ll have a file called “manifest” in the profile directory.
> >> This is unrelated to whether you used a manifest to create the profile
> >> or not.
> >
> > I see! Yes, it appeared twice.
>
> Looking more closely, it’s actually possible even now to create a
> profile with the exact same entry twice:
>
> --8<---------------cut here---------------start------------->8---
> $ guix package -p foo -i gnutls gnutls
> La jenaj pakoj estos instalataj:
>     gnutls      3.5.13  /gnu/store/g09is0bw144d8zrd059fiarqmjq7vr
> 8a-gnutls-3.5.13
>    gnutls       3.5.13  /gnu/store/g09is0bw144d8zrd059fiarqmjq7vr
> 8a-gnutls-3.5.13
>
> substitute: updating list of substitutes from 'https://berlin.guixsd.org'...
> 100.0%
> substitute: updating list of substitutes from '
> https://mirror.hydra.gnu.org'... 100.0%
> La jenaj derivoj estos konstruataj:
>    /gnu/store/viykf0jcxc9c51yl0p1023b75khad7jn-profile.drv
>    /gnu/store/yi996sf93p8n15ijf27hcck1b6prywrl-info-dir.drv
>    /gnu/store/ki7jrd29isi0l1zk93vrqd1p4by08nw7-fonts-dir.drv
>    /gnu/store/0xkp49578vpjc7q96kyg052v4jhx439m-ca-certificate-bundle.drv
>    /gnu/store/yxbrnjbxjcdx6nvs8l0wm8236mvx14l7-manual-database.drv
> Creating manual page database...
> 144 entries processed in 0.1 s
> pakoj 2 en profilo
> La jenaj medi-variablaj difinoj povos esti necesaj:
>    export PATH="foo/bin${PATH:+:}$PATH"
> --8<---------------cut here---------------end--------------->8---
>
> Weird, but no big deal since they are really the same entry.
>
> (What’s *not* permitted is installing several “gnutls” packages having a
> different store file name.  See ‘check-for-collisions’ in (guix
> profiles).)
>
> What should we do?  Status quo?  Throwing a ‘delete-duplicates’ call?
> Let’s have a poll!  ;-)
>
>
I think if the manifest is generated automatically, then
duplicates can be removed automatically reducing clobber,
(most probably the user doesn't care anyways),
but when using a manifest file there should be a warning
about it, so the problem will not be retained.
(These users most probably care about this,
I think this can point to problematic manifest
authoring practices.)

> Ludo’.